Attribute VB_Name = "MODUL_PACMAN1"
Option Explicit
'******************************************************************************

Public KEY_DOWN(255) As Byte, KEY_LAST As Byte
Public Pfad As String
Public SICHT_X As Long, SICHT_Y As Long

Public COUNT_DOTS As Long
Public LEVEL_SCORE As Long
Public LEVEL_NEXT As Long
Public HIGHSCORE_EINTRAGEN As Long

'******************************************************************************

Public Spr(400) As Sprite
Public Obj(200) As ObjType

Public Const NR_NOTHING = 200
Public Const NR_ANIMATOR = 201

Public Const NR_PACMAN = 1
Public Const ID_PACMAN_LEFT = 24
Public Const ID_PACMAN_RIGHT = 0
Public Const ID_PACMAN_UP = 72
Public Const ID_PACMAN_DOWN = 48

Public Const NR_MONSTER_BLUE = 2
Public Const ID_MONSTER_BLUE = 96
Public Const NR_MONSTER_GREEN = 3
Public Const ID_MONSTER_GREEN = 108
Public Const NR_MONSTER_RED = 4
Public Const ID_MONSTER_RED = 120
Public Const NR_MONSTER_BROWN = 5
Public Const ID_MONSTER_BROWN = 132
Public Const NR_MONSTER_MAGENTA = 6
Public Const ID_MONSTER_MAGENTA = 144
Public Const NR_MONSTER_HIPPIE = 7
Public Const ID_MONSTER_HIPPIE = 156

Public Const NR_ITEM_COOL = 8
Public Const ID_ITEM_COOL = 172
Public Const NR_ITEM_INVISIBLE = 9
Public Const ID_ITEM_INVISIBLE = 176
Public Const NR_ITEM_TERMINATOR = 10
Public Const ID_ITEM_TERMINATOR = 180

Public Const NR_ITEM_DEAD = 11
Public Const ID_ITEM_DEAD = 184
Public Const NR_ITEM_KEY1 = 12
Public Const ID_ITEM_KEY1 = 188
Public Const NR_ITEM_KEY2 = 13
Public Const ID_ITEM_KEY2 = 192

Public Const NR_DOT = 14
Public Const ID_DOT = 168
Public Const NR_DOOR1 = 15
Public Const ID_DOOR1 = 196
Public Const NR_DOOR2 = 16
Public Const ID_DOOR2 = 197
Public Const NR_FLAG = 17
Public Const ID_FLAG = 204

Public Const NR_SWITCH_RED = 18
Public Const ID_SWITCH_RED = 240
Public Const NR_SWITCH_GREEN = 19
Public Const ID_SWITCH_GREEN = 242
Public Const NR_SWITCH_BLUE = 20
Public Const ID_SWITCH_BLUE = 244
Public Const NR_SWITCH_YELLOW = 21
Public Const ID_SWITCH_YELLOW = 246

Public Const NR_BLOCK_RED = 22
Public Const ID_BLOCK_RED = 248
Public Const NR_BLOCK_GREEN = 23
Public Const ID_BLOCK_GREEN = 249
Public Const NR_BLOCK_BLUE = 24
Public Const ID_BLOCK_BLUE = 250
Public Const NR_BLOCK_YELLOW = 25
Public Const ID_BLOCK_YELLOW = 251

Public Const NR_TELE_RED = 26
Public Const ID_TELE_RED = 252
Public Const NR_TELE_YELLOW = 27
Public Const ID_TELE_YELLOW = 264
Public Const NR_TELE_BLUE = 28
Public Const ID_TELE_BLUE = 260
Public Const NR_TELE_GREEN = 29
Public Const ID_TELE_GREEN = 256

Public Const ID_WALL_GRAY = 276
Public Const ID_WALL_YELLOW = 280
Public Const ID_WALL_ORANGE = 284
Public Const ID_WALL_RED = 288
Public Const ID_WALL_MAGENTA = 292
Public Const ID_WALL_BLUE = 296
Public Const ID_WALL_CYAN = 300
Public Const ID_WALL_GREEN = 304
Public Const ID_WALL_BROWN = 308

Public Const ID_ENERGY = 216
Public Const ID_TIME = 233

' Diese Prozedur wird aufgerufen, um darauf zu reagieren, da Pacman ein
' Monster berhrt hat. Normalerweise bekommt Pacman dann Energie abgezogen.
' Hat Pacman jedoch die "Terminator-Rune", so wird dem Monster energie
' abgezogen
Public Sub MONSTER_COLL(Self As ObjType, Other As ObjType, Hit As Long, Speed As Long, FRAME As Long)
  If Other.T = NR_PACMAN Then
    If OBJ_ITEM_HAVE(Other, NR_ITEM_TERMINATOR) Then
      Self.E = Self.E - 10
      Call WAV_PLAYBACK(Pfad & "DOT.WAV")
      If Self.E < 0 Then
        Self.T = NR_ANIMATOR
        Self.R3 = FRAME + 8
        LEVEL_SCORE = LEVEL_SCORE + Hit * 2
        Call WAV_PLAYBACK(Pfad & "MONSTER.WAV")
      End If
    Else
      Other.E = Other.E - Hit
    End If
  Else
    Self.x = Self.OX
    Self.y = Self.OY
    Call MONSTER_RANDOM_SPEED(Self, Speed)
  End If
End Sub

Public Sub MONSTER_DRAW(Self As ObjType, Default As Long)
  OBJ_ANIMATE Self.R1, 3, Self.R2, 3
  If OBJ_ITEM_HAVE(Obj(0), NR_ITEM_TERMINATOR) Then
    Self.FRAME = Spr(Default + Self.R2 + 4)
  Else
    Self.FRAME = Spr(Default + Self.R2)
  End If
  If Self.SX = 0 And Self.SY = 0 Then
    Call MONSTER_RANDOM_SPEED(Self, 2)
  End If
End Sub

Public Sub MONSTER_HUNT(Self As ObjType, View As Long, Speed As Long)
  Dim PacX As Long, PacY As Long, MyX As Long, MyY As Long
   
    If Obj(0).V = 0 Then Exit Sub

    If Abs(Obj(0).x - Self.x) < View Then
      If Abs(Obj(0).y - Self.y) < View Then
        Self.SX = 0
        Self.SY = 0

        PacX = Fix(Obj(0).x / Speed)
        PacY = Fix(Obj(0).y / Speed)
        MyX = Fix(Self.x / Speed)
        MyY = Fix(Self.y / Speed)

        If OBJ_ITEM_HAVE(Obj(0), NR_ITEM_TERMINATOR) = 0 Then
          If PacX < MyX And OBJ_LEFT(Self, 20) Then Self.SX = -Speed
          If PacX > MyX And OBJ_RIGHT(Self, 20) Then Self.SX = Speed
          If PacY < MyY And OBJ_UP(Self, 20) Then Self.SY = -Speed
          If PacY > MyY And OBJ_DOWN(Self, 20) Then Self.SY = Speed
        Else
          If PacX < MyX And OBJ_RIGHT(Self, 20) Then Self.SX = Speed
          If PacX > MyX And OBJ_LEFT(Self, 20) Then Self.SX = -Speed
          If PacY < MyY And OBJ_DOWN(Self, 20) Then Self.SY = Speed
          If PacY > MyY And OBJ_UP(Self, 20) Then Self.SY = -Speed
        End If
        
        If Self.SX = 0 And Self.SY = 0 Then
           Call MONSTER_RANDOM_SPEED(Self, Speed)
        End If
      End If
    End If
End Sub

Public Sub MONSTER_MOVE(Self As ObjType, Par1 As Long, Par2 As Long, Speed As Long)
  Dim Ways As Long, Chance As Long
  
    Self.OX = Self.x
    Self.OY = Self.y
    Self.x = Self.x + Par1
    Self.y = Self.y + Par2
    OBJ_COLL_FIELD Self
                    
    Ways = 0
    If OBJ_LEFT(Self, 20) Then Ways = Ways + 1
    If OBJ_RIGHT(Self, 20) Then Ways = Ways + 1
    If OBJ_UP(Self, 20) Then Ways = Ways + 1
    If OBJ_DOWN(Self, 20) Then Ways = Ways + 1
                    
    Chance = 2
    If Ways > 2 Then Chance = 20

    If Rnd * 200 < Chance Then
      Call MONSTER_RANDOM_SPEED(Self, Speed)
    End If
End Sub

Public Sub MONSTER_RANDOM_SPEED(Self As ObjType, S As Long)
  Dim a As Long
  
    a = Fix(Rnd * 4)
    Select Case a
     Case 0: Self.SX = -S: Self.SY = 0
     Case 1: Self.SX = 0: Self.SY = -S
     Case 2: Self.SX = S: Self.SY = 0
     Case 3: Self.SX = 0: Self.SY = S
    End Select
End Sub

Public Sub PACMAN_INIT()
  Dim b1 As Long, b2 As Long, b3 As Long, b4 As Long
  Dim m1 As Long, m2 As Long, m3 As Long, m4 As Long
  Dim Anzahl  As Long
  
    Pfad = App.Path
    If Right$(Pfad$, 1) <> "\" Then Pfad$ = Pfad$ + "\"
    
    MAX_DIFF = 3
    
    b1 = RES_NEW(): RES_LOAD b1, Pfad$ + "BIT\PACMAN.BMP"
    m1 = RES_NEW(): RES_LOAD m1, Pfad$ + "MASKE\PACMAN.BMP"
    
    b2 = RES_NEW(): RES_LOAD b2, Pfad$ + "BIT\MONSTER.BMP"
    m2 = RES_NEW(): RES_LOAD m2, Pfad$ + "MASKE\MONSTER.BMP"

    b3 = RES_NEW(): RES_LOAD b3, Pfad$ + "BIT\OBJECTS.BMP"
    m3 = RES_NEW(): RES_LOAD m3, Pfad$ + "MASKE\OBJECTS.BMP"
    
    b4 = RES_NEW(): RES_LOAD b4, Pfad$ + "BIT\WALLS.BMP"
    m4 = RES_NEW(): RES_LOAD m4, Pfad$ + "MASKE\WALLS.BMP"

    Anzahl = 0
    Call SPRITE_SET_MESH(Spr(), Anzahl, 12, 8, 20, 20, RESSOURCEN.RES(b1), RESSOURCEN.RES(m1))
    Call SPRITE_SET_MESH(Spr(), Anzahl, 12, 6, 20, 20, RESSOURCEN.RES(b2), RESSOURCEN.RES(m2))
    Call SPRITE_SET_MESH(Spr(), Anzahl, 12, 9, 20, 20, RESSOURCEN.RES(b3), RESSOURCEN.RES(m3))
    Call SPRITE_SET_MESH(Spr(), Anzahl, 12, 4, 20, 20, RESSOURCEN.RES(b4), RESSOURCEN.RES(m4))
End Sub

Public Sub PACMAN_LOAD(Datei As String, BACK As String)
  Dim m As Long, x As Long, y As Long, AObj As Long
  Dim a As String
  Dim Zeilen As Long, Spalten As Long, Zeichen As String
  
    On Local Error Resume Next
    
    MAIN.BACK.Picture = LoadPicture(Pfad & "ELSE\" + BACK)

    COUNT_DOTS = 0
    
    Open Pfad & Datei For Input As #1
      Do
        Line Input #1, a
        Zeilen = Zeilen + 1
      Loop Until EOF(1)
    Close #1
    Spalten = Len(a)

    FIELD_SIZE Spalten - 1, Zeilen - 1, 20, 20
    
    For m = 0 To UBound(Obj)
      Call OBJ_CLEAR(Obj(m))
    Next m
    
    KEY_DOWN(37) = 0
    KEY_DOWN(38) = 0
    KEY_DOWN(39) = 0
    KEY_DOWN(40) = 0

    y = 0
    AObj = 0
    Call OBJ_SET(Obj(AObj), 0, 0, 100, 0, 0, NR_PACMAN, Spr(ID_PACMAN_DOWN), 1)
    AObj = AObj + 1

    Open Pfad$ + Datei$ For Input As #1
    Do
      Line Input #1, a$
      For x = 0 To Len(a$) - 1
        Zeichen = Mid$(a$, x + 1, 1)
        
        Select Case Zeichen
          Case "!": Call FIELD_SET(x, y, 1, Spr(ID_WALL_GRAY + Fix(Rnd * 4)), 1)
          Case Chr$(34): Call FIELD_SET(x, y, 1, Spr(ID_WALL_YELLOW + Fix(Rnd * 4)), 1)
          Case "": Call FIELD_SET(x, y, 1, Spr(ID_WALL_ORANGE + Fix(Rnd * 4)), 1)
          Case "$": Call FIELD_SET(x, y, 1, Spr(ID_WALL_RED + Fix(Rnd * 4)), 1)
          Case "%": Call FIELD_SET(x, y, 1, Spr(ID_WALL_MAGENTA + Fix(Rnd * 4)), 1)
          Case "&": Call FIELD_SET(x, y, 1, Spr(ID_WALL_BLUE + Fix(Rnd * 4)), 1)
          Case "/": Call FIELD_SET(x, y, 1, Spr(ID_WALL_CYAN + Fix(Rnd * 4)), 1)
          Case "(": Call FIELD_SET(x, y, 1, Spr(ID_WALL_GREEN + Fix(Rnd * 4)), 1)
          Case ")": Call FIELD_SET(x, y, 1, Spr(ID_WALL_BROWN + Fix(Rnd * 4)), 1)

          Case "P": Obj(0).x = x * 20: Obj(0).y = y * 20
          
          Case "C": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_COOL, Spr(ID_ITEM_COOL), 1): AObj = AObj + 1
          Case "I": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_INVISIBLE, Spr(ID_ITEM_INVISIBLE), 1): AObj = AObj + 1
          Case "T": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_TERMINATOR, Spr(ID_ITEM_TERMINATOR), 1): AObj = AObj + 1

          Case "X": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_DEAD, Spr(ID_ITEM_DEAD), 1): AObj = AObj + 1

          Case "1": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_BLUE, Spr(ID_MONSTER_BLUE), 1): AObj = AObj + 1
          Case "2": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_GREEN, Spr(ID_MONSTER_GREEN), 1): AObj = AObj + 1
          Case "3": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_RED, Spr(ID_MONSTER_RED), 1): AObj = AObj + 1
          Case "4": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_BROWN, Spr(ID_MONSTER_BROWN), 1): AObj = AObj + 1
          Case "5": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_MAGENTA, Spr(ID_MONSTER_MAGENTA), 1): AObj = AObj + 1
          Case "6": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_MONSTER_HIPPIE, Spr(ID_MONSTER_HIPPIE), 1): AObj = AObj + 1
              
          Case "k": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_KEY1, Spr(ID_ITEM_KEY1), 1): AObj = AObj + 1
          Case "K": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_ITEM_KEY2, Spr(ID_ITEM_KEY2), 1): AObj = AObj + 1

          Case "d": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_DOOR1, Spr(ID_DOOR1), 1): AObj = AObj + 1
          Case "D": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_DOOR2, Spr(ID_DOOR2), 1): AObj = AObj + 1

          Case ".": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_DOT, Spr(ID_DOT), 1): AObj = AObj + 1
                    COUNT_DOTS = COUNT_DOTS + 1

          Case "F": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_FLAG, Spr(ID_FLAG), 1): AObj = AObj + 1

          Case "R": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_SWITCH_RED, Spr(ID_SWITCH_RED), 1): AObj = AObj + 1
          Case "G": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_SWITCH_GREEN, Spr(ID_SWITCH_GREEN), 1): AObj = AObj + 1
          Case "B": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_SWITCH_BLUE, Spr(ID_SWITCH_BLUE), 1): AObj = AObj + 1
          Case "Y": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_SWITCH_YELLOW, Spr(ID_SWITCH_YELLOW), 1): AObj = AObj + 1

          Case "r": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_BLOCK_RED, Spr(ID_BLOCK_RED), 1): AObj = AObj + 1
          Case "g": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_BLOCK_GREEN, Spr(ID_BLOCK_GREEN), 1): AObj = AObj + 1
          Case "b": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_BLOCK_BLUE, Spr(ID_BLOCK_BLUE), 1): AObj = AObj + 1
          Case "y": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_BLOCK_YELLOW, Spr(ID_BLOCK_YELLOW), 1): AObj = AObj + 1

          Case "7": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_TELE_RED, Spr(ID_TELE_RED), 1): AObj = AObj + 1
          Case "8": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_TELE_GREEN, Spr(ID_TELE_GREEN), 1): AObj = AObj + 1
          Case "9": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_TELE_BLUE, Spr(ID_TELE_BLUE), 1): AObj = AObj + 1
          Case "0": Call OBJ_SET(Obj(AObj), x * 20, y * 20, 100, 0, 0, NR_TELE_YELLOW, Spr(ID_TELE_YELLOW), 1): AObj = AObj + 1
        End Select

      Next x
      y = y + 1
    Loop Until EOF(1)
    Close #1
End Sub

Public Sub PACMAN_RUN()
  Obj(0).SX = 0
  Obj(0).SY = 0

  If KEY_DOWN(38) And OBJ_UP(Obj(0), 4) Then Obj(0).SY = -4
  If KEY_DOWN(40) And OBJ_DOWN(Obj(0), 4) Then Obj(0).SY = 4
  If KEY_DOWN(37) And OBJ_LEFT(Obj(0), 4) Then Obj(0).SX = -4
  If KEY_DOWN(39) And OBJ_RIGHT(Obj(0), 4) Then Obj(0).SX = 4

  Call PACMAN_SHOW
End Sub

Public Sub PACMAN_SHOW()
  Dim m As Long, m2 As Long
  Dim Need As Long, PowerUp As Long, E As Long, Energy As Long
  
    SICHT_X = Fix(MAIN.DISPLAY.ScaleWidth / 2 - Obj(0).x)
    SICHT_Y = Fix(MAIN.DISPLAY.ScaleHeight / 2 - Obj(0).y)
    
    If SICHT_X > 0 Then SICHT_X = 0
    If SICHT_Y > 0 Then SICHT_Y = 0
    
    If SICHT_X + ((FIELD_X + 1) * FIELD_W - MAIN.DISPLAY.ScaleWidth) < 0 Then
      SICHT_X = -((FIELD_X + 1) * FIELD_W - MAIN.DISPLAY.ScaleWidth)
    End If
    
    If SICHT_Y + ((FIELD_Y + 1) * FIELD_H - MAIN.DISPLAY.ScaleHeight) < 0 Then
      SICHT_Y = -((FIELD_Y + 1) * FIELD_H - MAIN.DISPLAY.ScaleHeight)
    End If
    
    MAIN.DISPLAY.Cls
    Call FIELD_DRAW(MAIN.DISPLAY, SICHT_X, SICHT_Y)

    For m = 0 To UBound(Obj)
      Call OBJ_DRAW(Obj(m), SICHT_X, SICHT_Y, MAIN.DISPLAY)
    Next m

    For m = 0 To UBound(Obj)
      Call OBJ_EVENT(Obj(m), ID_MOVE, ObjDummy, Obj(m).SX, Obj(m).SY)
        
      If Obj(m).T = NR_PACMAN Then
        For m2 = m + 1 To UBound(Obj)
          Call OBJ_COLL_OBJ(Obj(m), Obj(m2))
        Next m2
      Else
        If Obj(m).SX <> 0 Or Obj(m).SY <> 0 Then
          For m2 = 0 To UBound(Obj)
            Need = 0
            
            Select Case Obj(m2).T
              Case NR_BLOCK_RED: Need = 1
              Case NR_BLOCK_BLUE: Need = 1
              Case NR_BLOCK_GREEN: Need = 1
              Case NR_BLOCK_YELLOW: Need = 1
              Case NR_DOOR1: Need = 1
              Case NR_DOOR2: Need = 1
            End Select
            
            If Need Then OBJ_COLL_OBJ Obj(m), Obj(m2)
          Next m2
        End If
      End If
    Next m
    
    PowerUp = 0
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_COOL)
    If E > PowerUp Then PowerUp = E
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_INVISIBLE)
    If E > PowerUp Then PowerUp = E
    E = OBJ_ITEM_ENERGY_GET(Obj(0), NR_ITEM_TERMINATOR)
    If E > PowerUp Then PowerUp = E

    If PowerUp > 0 Then
      PowerUp = 6 / 300 * PowerUp
      If PowerUp <= 6 Then
        Call SPRITE_DRAW(Spr(ID_TIME + 6 - PowerUp), 25, 5, MAIN.DISPLAY)
      End If
    End If

    If Obj(0).E >= 0 Then
      Energy = 16 / 100 * Obj(0).E
      Call SPRITE_DRAW(Spr(ID_ENERGY + 16 - Energy), 5, 5, MAIN.DISPLAY)
    Else
      LEVEL_NEXT = -2
    End If
    
    MAIN.DISPLAY.Refresh
End Sub

Public Sub USER_EVENT(Self As ObjType, MESSAGE, Other As ObjType, Par1 As Long, Par2 As Long)
  If Self.T = 0 Then Exit Sub
    
  Call USER_EVENT_PACMAN(Self, MESSAGE, Other, Par1, Par2)
  Call USER_EVENT_DOORS(Self, MESSAGE, Other, Par1, Par2)
  Call USER_EVENT_ITEM(Self, MESSAGE, Other, Par1, Par2)
  Call USER_EVENT_MONSTER(Self, MESSAGE, Other, Par1, Par2)
  Call USER_EVENT_SWITCH(Self, MESSAGE, Other, Par1, Par2)
  Call USER_EVENT_TELE(Self, MESSAGE, Other, Par1, Par2)
End Sub

Public Sub USER_EVENT_DOORS(Self As ObjType, MESSAGE, Other As ObjType, Par1, Par2)
  Dim Anzahl As Long
  
    Select Case Self.T
        
      '**********************************************************************
      Case NR_ITEM_KEY1
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY1) + 1
              Call OBJ_ITEM_ENERGY_SET(Other, NR_ITEM_KEY1, Anzahl)
              Call OBJ_CLEAR(Self)
              Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
            Self.FRAME = Spr(ID_ITEM_KEY1 + Self.R2)

        End Select

      '**********************************************************************
      Case NR_ITEM_KEY2
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY2) + 1
              Call OBJ_ITEM_ENERGY_SET(Other, NR_ITEM_KEY2, Anzahl)
              Call OBJ_CLEAR(Self)
              Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
            Self.FRAME = Spr(ID_ITEM_KEY2 + Self.R2)
        End Select

      '**********************************************************************
      Case NR_DOOR1
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              If OBJ_ITEM_HAVE(Other, NR_ITEM_KEY1) Then
                Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY1) - 1
                Call OBJ_ITEM_ENERGY_SET(Other, NR_ITEM_KEY1, Anzahl)
                Call OBJ_CLEAR(Self)
                Call WAV_PLAYBACK(Pfad & "TR.WAV")
              Else
                Other.x = Other.OX
                Other.y = Other.OY
                Other.SX = 0
                Other.SY = 0
              End If
            End If
        End Select

      '**********************************************************************
      Case NR_DOOR2
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              If OBJ_ITEM_HAVE(Other, NR_ITEM_KEY2) Then
                Anzahl = OBJ_ITEM_ENERGY_GET(Other, NR_ITEM_KEY2) - 1
                Call OBJ_ITEM_ENERGY_SET(Other, NR_ITEM_KEY2, Anzahl)
                Call OBJ_CLEAR(Self)
                Call WAV_PLAYBACK(Pfad & "TR.WAV")
              Else
                Other.x = Other.OX
                Other.y = Other.OY
                Other.SX = 0
                Other.SY = 0
              End If
            End If
                
        End Select
   
    End Select
End Sub

Public Sub USER_EVENT_ITEM(Self As ObjType, MESSAGE, Other As ObjType, Par1 As Long, Par2 As Long)
    
  Select Case Self.T

    '**********************************************************************
    Case NR_ITEM_COOL:  ' Speed-PowerUp
      Select Case MESSAGE
        Case ID_COLL
          If Other.T = NR_PACMAN Then
            Call OBJ_ITEM_DROP(Other, NR_ITEM_COOL)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_INVISIBLE)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_TERMINATOR)
            Call OBJ_ITEM_GET(Other, NR_ITEM_COOL, 300)
            Call OBJ_CLEAR(Self)
            LEVEL_SCORE = LEVEL_SCORE + 20
            Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
          End If
    
        Case ID_DRAW
          Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
          Self.FRAME = Spr(ID_ITEM_COOL + Self.R2)
      End Select

    '**********************************************************************
    Case NR_ITEM_INVISIBLE:  ' Unsichtbar-PowerUp
      Select Case MESSAGE
        Case ID_COLL
          If Other.T = NR_PACMAN Then
            Call OBJ_ITEM_DROP(Other, NR_ITEM_COOL)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_INVISIBLE)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_TERMINATOR)
            
            Call OBJ_ITEM_GET(Other, NR_ITEM_INVISIBLE, 300)
            Call OBJ_CLEAR(Self)
            
            LEVEL_SCORE = LEVEL_SCORE + 10
            Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
          End If
          
        Case ID_DRAW
          Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
          Self.FRAME = Spr(ID_ITEM_INVISIBLE + Self.R2)
      End Select

    '**********************************************************************
    Case NR_ITEM_TERMINATOR:  ' Terminator-PowerUp
      Select Case MESSAGE
        Case ID_COLL
          If Other.T = NR_PACMAN Then
            Call OBJ_ITEM_DROP(Other, NR_ITEM_COOL)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_INVISIBLE)
            Call OBJ_ITEM_DROP(Other, NR_ITEM_TERMINATOR)
            Call OBJ_ITEM_GET(Other, NR_ITEM_TERMINATOR, 300)
            Call OBJ_CLEAR(Self)
            LEVEL_SCORE = LEVEL_SCORE + 10
            Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
          End If
          
        Case ID_DRAW
          Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
          Self.FRAME = Spr(ID_ITEM_TERMINATOR + Self.R2)
      End Select

    '**********************************************************************
    Case NR_ITEM_DEAD:  ' Todes-"PowerUp"
      Select Case MESSAGE
        Case ID_COLL
          If Other.T = NR_PACMAN Then
            Other.E = Other.E - 80
            Call OBJ_CLEAR(Self)
            Call WAV_PLAYBACK(Pfad & "ITEM.WAV")
          End If
          
        Case ID_DRAW
          Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
          Self.FRAME = Spr(ID_ITEM_DEAD + Self.R2)
      End Select

  End Select
End Sub

Public Sub USER_EVENT_MONSTER(Self As ObjType, MESSAGE, _
                              Other As ObjType, _
                              Par1 As Long, Par2 As Long)
    
  Select Case Self.T

    '**********************************************************************
    Case NR_MONSTER_BLUE
      Select Case MESSAGE
        Case ID_DRAW:      Call MONSTER_DRAW(Self, ID_MONSTER_BLUE)
                
        Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 2)
                           Call MONSTER_HUNT(Self, 20, 2)
        
        Case ID_COLL, _
             ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 2, 2, ID_MONSTER_BLUE)
             
      End Select

    '**********************************************************************
    Case NR_MONSTER_GREEN
      Select Case MESSAGE
        Case ID_DRAW:       Call MONSTER_DRAW(Self, ID_MONSTER_GREEN)
                
         Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 2)
                            Call MONSTER_HUNT(Self, 40, 2)
         
         Case ID_COLL, _
              ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 1, 2, ID_MONSTER_GREEN)
      End Select

    '***********************************************************************
    Case NR_MONSTER_RED
      Select Case MESSAGE
        Case ID_DRAW:      Call MONSTER_DRAW(Self, ID_MONSTER_RED)
        
        Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 3)
                           Call MONSTER_HUNT(Self, 40, 3)
                      
        Case ID_COLL, _
             ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 4, 3, ID_MONSTER_RED)
      End Select

    '**********************************************************************
    Case NR_MONSTER_BROWN
      Select Case MESSAGE
        Case ID_DRAW:      Call MONSTER_DRAW(Self, ID_MONSTER_BROWN)
        
        Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 3)
                           Call MONSTER_HUNT(Self, 80, 3)
        
        Case ID_COLL, _
             ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 3, 3, ID_MONSTER_BROWN)
      End Select

      '**********************************************************************
      Case NR_MONSTER_MAGENTA
        Select Case MESSAGE
          Case ID_DRAW:      Call MONSTER_DRAW(Self, ID_MONSTER_MAGENTA)
          
          Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 3)
                             Call MONSTER_HUNT(Self, 80, 5)
          
          Case ID_COLL, _
               ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 8, 3, ID_MONSTER_MAGENTA)
        End Select

      '**********************************************************************
      Case NR_MONSTER_HIPPIE
        Select Case MESSAGE
          Case ID_DRAW:      Call MONSTER_DRAW(Self, ID_MONSTER_HIPPIE)
          
          Case ID_MOVE:      Call MONSTER_MOVE(Self, Par1, Par2, 3)
                             Call MONSTER_HUNT(Self, 100, 6)
          
          Case ID_COLL, _
               ID_COLL_WALL: Call MONSTER_COLL(Self, Other, 20, 4, ID_MONSTER_HIPPIE)
        End Select

    End Select
End Sub

Public Sub USER_EVENT_PACMAN(Self As ObjType, MESSAGE, Other As ObjType, Par1 As Long, Par2 As Long)
  Dim m As Long, Energy As Long, Dots As Long
  
    Select Case Self.T


      '**********************************************************************
      Case NR_PACMAN:     ' Pacman
        Select Case MESSAGE
          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 3, Self.R2, 3)
            Self.R3 = 0
            Self.V = 1

            If OBJ_ITEM_HAVE(Self, NR_ITEM_COOL) Then
              Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_COOL)
              If Energy > 0 Then
                Call OBJ_ITEM_ENERGY_SET(Self, NR_ITEM_COOL, Energy - 1)
                Self.R3 = 12
                For m = 0 To UBound(Obj)
                  If Obj(m).T <> NR_PACMAN Then
                    Obj(m).x = Obj(m).OX
                    Obj(m).y = Obj(m).OY
                  End If
                Next m
              Else
                Call OBJ_ITEM_DROP(Self, NR_ITEM_COOL)
              End If
            End If
                    
            If OBJ_ITEM_HAVE(Self, NR_ITEM_INVISIBLE) Then
              Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_INVISIBLE)
              If Energy > 0 Then
                Call OBJ_ITEM_ENERGY_SET(Self, NR_ITEM_INVISIBLE, Energy - 1)
                Self.R3 = 8
                Self.V = 0
              Else
                Call OBJ_ITEM_DROP(Self, NR_ITEM_INVISIBLE)
              End If
            End If

            If OBJ_ITEM_HAVE(Self, NR_ITEM_TERMINATOR) Then
              Energy = OBJ_ITEM_ENERGY_GET(Self, NR_ITEM_TERMINATOR)
              If Energy > 0 Then
                Call OBJ_ITEM_ENERGY_SET(Self, NR_ITEM_TERMINATOR, Energy - 1)
                Self.R3 = 4
                Self.SX = Self.SX * 1.5
                Self.SY = Self.SY * 1.5
              Else
                Call OBJ_ITEM_DROP(Self, NR_ITEM_TERMINATOR)
              End If
            End If

            Self.FRAME = Spr(ID_PACMAN_DOWN + Self.R3)
            If Self.SY < 0 Then Self.FRAME = Spr(ID_PACMAN_UP + Self.R2 + Self.R3)
            If Self.SY > 0 Then Self.FRAME = Spr(ID_PACMAN_DOWN + Self.R2 + Self.R3)
            If Self.SX > 0 Then Self.FRAME = Spr(ID_PACMAN_RIGHT + Self.R2 + Self.R3)
            If Self.SX < 0 Then Self.FRAME = Spr(ID_PACMAN_LEFT + Self.R2 + Self.R3)


          Case ID_MOVE
            Self.OX = Self.x
            Self.OY = Self.y
            Self.x = Self.x + Par1
            Self.y = Self.y + Par2
            Call OBJ_COLL_FIELD(Self)

          Case ID_COLL_WALL
            Self.x = Self.OX
            Self.y = Self.OY
            Self.SX = Self.SX / 2
            Self.SY = Self.SY / 2
            Call OBJ_EVENT(Self, ID_MOVE, ObjDummy, Self.SX, Self.SY)
        End Select

      '**********************************************************************
      Case NR_DOT:        ' Punkte
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              Dots = OBJ_ITEM_ENERGY_GET(Other, NR_DOT) + 1
              OBJ_ITEM_ENERGY_SET Other, NR_DOT, Dots
              Call OBJ_CLEAR(Self)
              LEVEL_SCORE = LEVEL_SCORE + 5
              Call WAV_PLAYBACK(Pfad & "DOT.WAV")
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(ID_DOT + Self.R2)

          End Select
        
      '**********************************************************************
      Case NR_FLAG:        ' Flagge
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              If COUNT_DOTS = OBJ_ITEM_ENERGY_GET(Other, NR_DOT) Then
                LEVEL_NEXT = 1
                LEVEL_SCORE = LEVEL_SCORE + 50
              End If
            End If

          Case ID_DRAW
            If COUNT_DOTS = OBJ_ITEM_ENERGY_GET(Obj(0), NR_DOT) Then
              Call OBJ_ANIMATE(Self.R1, 1, Self.R2, 9)
              Self.FRAME = Spr(ID_FLAG + Self.R2)
            Else
              Self.FRAME = Spr(ID_FLAG)
            End If
        End Select
        
      '**********************************************************************
      Case NR_ANIMATOR:
        Select Case MESSAGE
          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(Self.R3 + Self.R2)
        End Select
            
    End Select
End Sub

Public Sub USER_EVENT_SWITCH(Self As ObjType, MESSAGE, Other As ObjType, Par1 As Long, Par2 As Long)
  Dim m As Long
  
    Select Case Self.T
  
      '**********************************************************************
      Case NR_SWITCH_RED
        Select Case MESSAGE
                
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              Self.R1 = 1
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_BLOCK_RED Then OBJ_CLEAR Obj(m)
              Next m
              Call WAV_PLAYBACK(Pfad & "SCHALTER.WAV")
            End If

          Case ID_DRAW
            Self.FRAME = Spr(ID_SWITCH_RED + Self.R1)
        End Select

      '**********************************************************************
      Case NR_SWITCH_GREEN
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              Self.R1 = 1
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_BLOCK_GREEN Then OBJ_CLEAR Obj(m)
              Next m
              Call WAV_PLAYBACK(Pfad & "SCHALTER.WAV")
            End If

          Case ID_DRAW
            Self.FRAME = Spr(ID_SWITCH_GREEN + Self.R1)

        End Select
      
      '**********************************************************************
      Case NR_SWITCH_BLUE
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              Self.R1 = 1
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_BLOCK_BLUE Then OBJ_CLEAR Obj(m)
              Next m
              Call WAV_PLAYBACK(Pfad & "SCHALTER.WAV")
            End If

          Case ID_DRAW
            Self.FRAME = Spr(ID_SWITCH_BLUE + Self.R1)

        End Select
      
      '**********************************************************************
      Case NR_SWITCH_YELLOW
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              Self.R1 = 1
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_BLOCK_YELLOW Then OBJ_CLEAR Obj(m)
              Next m
              Call WAV_PLAYBACK(Pfad & "SCHALTER.WAV")
            End If

          Case ID_DRAW
            Self.FRAME = Spr(ID_SWITCH_YELLOW + Self.R1)
        End Select

      '**********************************************************************
      Case NR_BLOCK_RED, NR_BLOCK_GREEN, NR_BLOCK_BLUE, NR_BLOCK_YELLOW
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN Then
              Other.x = Other.OX
              Other.y = Other.OY
              Other.SX = 0
              Other.SY = 0
            End If
          End Select
    End Select
End Sub

Public Sub USER_EVENT_TELE(Self As ObjType, MESSAGE, Other As ObjType, Par1 As Long, Par2 As Long)
  Dim m As Long
  
    Select Case Self.T
      
      '**********************************************************************
      Case NR_TELE_RED
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_TELE_RED And (Obj(m).x <> Self.x Or Obj(m).y <> Self.y) Then
                  Other.x = Obj(m).x
                  Other.y = Obj(m).y
                  Call WAV_PLAYBACK(Pfad & "TELEPORT.WAV")
                  If OBJ_LEFT(Obj(m), 20) Then Other.x = Other.x - 20: Exit Sub
                  If OBJ_RIGHT(Obj(m), 20) Then Other.x = Other.x + 20: Exit Sub
                  If OBJ_UP(Obj(m), 20) Then Other.y = Other.y - 20: Exit Sub
                  If OBJ_DOWN(Obj(m), 20) Then Other.y = Other.y + 20: Exit Sub
                End If
              Next m
            End If


          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(ID_TELE_RED + Self.R2 + Self.R3)

        End Select

      '**********************************************************************
      Case NR_TELE_BLUE
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_TELE_BLUE And (Obj(m).x <> Self.x Or Obj(m).y <> Self.y) Then
                  Other.x = Obj(m).x
                  Other.y = Obj(m).y
                  Call WAV_PLAYBACK(Pfad & "TELEPORT.WAV")
                  If OBJ_LEFT(Obj(m), 20) Then Other.x = Other.x - 20: Exit Sub
                  If OBJ_RIGHT(Obj(m), 20) Then Other.x = Other.x + 20: Exit Sub
                  If OBJ_UP(Obj(m), 20) Then Other.y = Other.y - 20: Exit Sub
                  If OBJ_DOWN(Obj(m), 20) Then Other.y = Other.y + 20: Exit Sub
                End If
              Next m
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(ID_TELE_BLUE + Self.R2 + Self.R3)
        End Select
  
      '**********************************************************************
      Case NR_TELE_GREEN
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_TELE_GREEN And (Obj(m).x <> Self.x Or Obj(m).y <> Self.y) Then
                  Other.x = Obj(m).x
                  Other.y = Obj(m).y
                  Call WAV_PLAYBACK(Pfad & "TELEPORT.WAV")
                  If OBJ_LEFT(Obj(m), 20) Then Other.x = Other.x - 20: Exit Sub
                  If OBJ_RIGHT(Obj(m), 20) Then Other.x = Other.x + 20: Exit Sub
                  If OBJ_UP(Obj(m), 20) Then Other.y = Other.y - 20: Exit Sub
                  If OBJ_DOWN(Obj(m), 20) Then Other.y = Other.y + 20: Exit Sub
                End If
              Next m
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(ID_TELE_GREEN + Self.R2 + Self.R3)
        End Select

      '**********************************************************************
      Case NR_TELE_YELLOW
        Select Case MESSAGE
          Case ID_COLL
            If Other.T = NR_PACMAN And Self.R1 = 0 Then
              For m = 0 To UBound(Obj)
                If Obj(m).T = NR_TELE_YELLOW And (Obj(m).x <> Self.x Or Obj(m).y <> Self.y) Then
                  Other.x = Obj(m).x
                  Other.y = Obj(m).y
                  Call WAV_PLAYBACK(Pfad & "TELEPORT.WAV")
                  If OBJ_LEFT(Obj(m), 20) Then Other.x = Other.x - 20: Exit Sub
                  If OBJ_RIGHT(Obj(m), 20) Then Other.x = Other.x + 20: Exit Sub
                  If OBJ_UP(Obj(m), 20) Then Other.y = Other.y - 20: Exit Sub
                  If OBJ_DOWN(Obj(m), 20) Then Other.y = Other.y + 20: Exit Sub
                End If
              Next m
            End If

          Case ID_DRAW
            Call OBJ_ANIMATE(Self.R1, 0, Self.R2, 3)
            Self.FRAME = Spr(ID_TELE_YELLOW + Self.R2 + Self.R3)
        End Select
      
    End Select
End Sub

